Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.flagstone.transform
Class FSGotoFrame2

    java.lang.Object
      com.flagstone.transform.FSTransformObject
          com.flagstone.transform.FSActionObject
              com.flagstone.transform.FSGotoFrame2

All Implemented Interfaces:
  java.lang.Cloneable

    public class FSGotoFrame2

extends FSActionObject

The FSGotoFrame2 action instructs the player to go to the named or numbered frame in the current movie's main time-line. It extends the functionality provided by the FSGotoFrame action by allowing the name of a frame, previously assigned using the FSFrameLabel object, to be specified.

Attributes
type | Identifies the data structure when it is encoded. Read-only.
play | A boolean flag indicating whether the Flash Player should start playing the frame as soon as it is loaded.
frameOffset | An offset added to the frame number of the stack to generate the final frame number that the timeline should move to.

Up to Flash Version 4, movies contained a single sequence of 65536 frames. In Flash 5 the concept of Scenes was added which allowed movies to contain 'pages' of frames. FSGotoFrame2 contains a frameOffset attribute which allows the frames in each scene to be referenced by its 'logical' number. The frameOffset for a given scene is added to the frame number to generate the 'physical' page number.

FSGotoFrame2 is a stack-based action. The name or number of the frame is pushed onto the stack before the FSGotoFrame2 action is executed. If a frameOffset is specified it is added to the number of the frame identified by the stack arguments to give the final frame number. Whether the movie starts playing the frame is controlled by the boolean attribute, play. When set to true the movie starts playing the frame as soon as it has been loaded by the Flash Player.

# Examples

Start playing a movie at the specified frame number:

     FSDoAction actions = new FSDoAction();

     actions.add(new FSPush(12));
     actions.add(new FSGotoFrame2(true));

Move to the named frame but do not start playing immediately:

     FSMovie movie = new FSMovie();
     FSDoAction actions = new FSDoAction();

     movie.add(new FSFrameLabel("FirstFrame"));

     actions.add(new FSPush("FirstFrame"));
     actions.add(new FSGotoFrame2(false));

To use the concept of scenes in a movie, divide the physical frames into a sequence of logical pages:

      int sceneSize = 1024;
      int scene = 5;
      boolean play = true;

      // Goto the first frame in scene 5.

      frameAction.add(new FSPush(1));
      frameAction.add(new FSGotoFrame2(scene*sceneSize, play);

FSGotoFrame2 is only used to control the main time-line of a movie. Controlling how an individual movie clip is played is handled by a different mechanism. From Flash 5 onward movie clips are defined as objects. The ExecuteMethod action is used to execute the gotoAndPlay() or gotoAndStop() methods that control a movie clip's time-line:

     // Push the arguments followed by the number of arguments onto the stack

     frameAction.add(new FSPush("frameName"));
     frameAction.add(new FSPush(1));

     // Get a reference to the object.

     frameAction.add(new FSPush("_root"));
     frameAction.add(new FSPush("movieClip"));
     frameAction.add(FSAction.GetAttribute());

     // Place the name of the method on the stack then execute it.

     frameAction.add(new FSPush("gotoAndPlay"));
     frameAction.add(FSAction.ExecuteMethod());

# History

The FSGotoFrame2 is a class for representing the ActionGotoFrame2 action of the Macromedia Flash (SWF) File Format Specification. It was introduced in Flash 4 and supersedes the FSGotoFrame action. In Flash 5 the frameOffset attribute was added which allows movies to be divided into a series of 'pages'.

Field Summary

Fields inherited from class com.flagstone.transform.FSActionObject
`Call, ExceptionHandler, GetUrl, GetUrl2, GotoFrame, GotoFrame2, GotoLabel, If, Jump, length, NewFunction, NewFunction2, Push, RegisterCopy, SetTarget, Table, type, WaitForFrame, WaitForFrame2, With`

Constructor Summary
`FSGotoFrame2(boolean aBool)` Constructs an FSGotoFrame2 object with the specified play flag setting.
`FSGotoFrame2(FSCoder coder)` Construct an FSGotoFrame2 object, initialising it with values decoded from an encoded object.
`FSGotoFrame2(FSGotoFrame2 obj)` Constructs an FSGotoFrame2 object by copying values from an existing object.
`FSGotoFrame2(int offset, boolean aBool)` Constructs an FSGotoFrame2 object with the specified play flag setting and frame offset for a given scene.

Method Summary
`void` | `appendDescription(java.lang.StringBuffer buffer, int depth)` AppendDescription is used to present a string description of the object including all nested objects up to a specified depth.
`void` | `decode(FSCoder coder)`
`void` | `encode(FSCoder coder)`
`boolean` | `equals(java.lang.Object anObject)` Returns true if anObject is equal to this one.
`int` | `getFrameOffset()` Gets the offset that will be added to the 'logical' frame number obtained from the stack to generate the 'physical' frame number.
`boolean` | `getPlayFrame()` Gets the play flag.
`int` | `length(FSCoder coder)`
`void` | `setFrameOffset(int offset)` Sets the offset that will be added to the 'logical' frame number obtained from the stack to generate the 'physical' frame number.
`void` | `setPlayFrame(boolean aBool)` Sets the play flag.

Methods inherited from class com.flagstone.transform.FSActionObject
`getType, length`

Methods inherited from class com.flagstone.transform.FSTransformObject
`clone, name, toString`

Methods inherited from class java.lang.Object
`finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Constructor Detail

### FSGotoFrame2

    public FSGotoFrame2(FSCoder coder)

  Construct an FSGotoFrame2 object, initialising it with values decoded from an encoded object.

  Parameters:
    `coder` - an FSCoder containing the binary data.

### FSGotoFrame2

    public FSGotoFrame2(boolean aBool)

  Constructs an FSGotoFrame2 object with the specified play flag setting.

  Parameters:
    `aBool` - true if the player should being playing the movie at the specified frame. false if the player should stop playing the movie.

### FSGotoFrame2

    public FSGotoFrame2(int offset,
                        boolean aBool)

  Constructs an FSGotoFrame2 object with the specified play flag setting and frame offset for a given scene.

  Parameters:
    `offset` - a number which will be added to the number of the frame popped from the stack to give the final frame number.
    `aBool` - true if the player should being playing the movie at the specified frame, false if the player should stop playing the movie.

### FSGotoFrame2

    public FSGotoFrame2(FSGotoFrame2 obj)

  Constructs an FSGotoFrame2 object by copying values from an existing object.

  Parameters:
    `obj` - an FSGotoFrame object.

Method Detail

### getFrameOffset

    public int getFrameOffset()

  Gets the offset that will be added to the 'logical' frame number obtained from the stack to generate the 'physical' frame number.

  Returns:
    an offset that will be added to the frame number obtained form the stack.

### setFrameOffset

    public void setFrameOffset(int offset)

  Sets the offset that will be added to the 'logical' frame number obtained from the stack to generate the 'physical' frame number.

  Parameters:
    `offset` - a number that will be added to the frame number obtained form the stack.

### getPlayFrame

    public boolean getPlayFrame()

  Gets the play flag.

  Returns:
    true if the player will being playing the movie at the specified frame, false otherwise.

### setPlayFrame

    public void setPlayFrame(boolean aBool)

  Sets the play flag.

  Parameters:
    `aBool` - true if the player should being playing the movie at the specified frame. false if the player should stop playing the movie.

### equals

    public boolean equals(java.lang.Object anObject)

  Description copied from class: `FSActionObject`
  Returns true if anObject is equal to this one. Objects are considered equal if they would generate identical binary data when they are encoded to a Flash file.

  Overrides:
    `equals` in class `FSActionObject`
  Returns:
    true if this object would be identical to anObject when encoded.

### appendDescription

    public void appendDescription(java.lang.StringBuffer buffer,
                                  int depth)

  Description copied from class: `FSTransformObject`
  AppendDescription is used to present a string description of the object including all nested objects up to a specified depth. This method provide a more controlled way of creating a string representation of an object since large objects such as font or shape definitions can contain dozens of nested objects. The representation of the object is appended to the StringBuffer, showing the name of the class and values of the attributes it contains. If the object contains any attributes that are objects then the object graph will be traversed up to the specified depth. If objects are nested at a level less than specified depth then the full string representation of the object is displayed. For objects at the specified depth only the name of the class is displayed. Any objects below this depth are not displayed.

  Specified by:
    `appendDescription` in class `FSTransformObject`
  Parameters:
    `buffer` - a StringBuffer to which the description of each object is appended.
    `depth` - the maximum level of nesting up to which objects will be displayed.

### length

    public int length(FSCoder coder)

  Overrides:
    `length` in class `FSActionObject`

### encode

    public void encode(FSCoder coder)

  Overrides:
    `encode` in class `FSActionObject`

### decode

    public void decode(FSCoder coder)

  Overrides:
    `decode` in class `FSActionObject`

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD